Index: /pjproject/trunk/aconfigure
===================================================================
--- /pjproject/trunk/aconfigure	(revision 5795)
+++ /pjproject/trunk/aconfigure	(revision 5796)
@@ -7905,4 +7905,5 @@
                 if test "x$with_ssl" != "xno" -a "x$with_ssl" != "x"; then
                     CFLAGS="$CFLAGS -I$with_ssl/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_ssl/include"
                     LDFLAGS="$LDFLAGS -L$with_ssl/lib"
                     { $as_echo "$as_me:${as_lineno-$LINENO}: result: Using SSL prefix... $with_ssl" >&5
@@ -8283,4 +8284,5 @@
                 if test "x$with_opencore_amr" != "xno" -a "x$with_opencore_amr" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opencore_amr/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opencore_amr/include"
                     LDFLAGS="$LDFLAGS -L$with_opencore_amr/lib"
                     { $as_echo "$as_me:${as_lineno-$LINENO}: result: Using OpenCORE AMR prefix... $with_opencore_amr" >&5
@@ -8289,4 +8291,5 @@
                 if test "x$with_opencore_amrwbenc" != "xno" -a "x$with_opencore_amrwbenc" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opencore_amrwbenc/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opencore_amrwbenc/include"
                     LDFLAGS="$LDFLAGS -L$with_opencore_amrwbenc/lib"
                     { $as_echo "$as_me:${as_lineno-$LINENO}: result: Using OpenCORE AMRWB-enc prefix... $with_opencore_amrwbenc" >&5
@@ -8494,5 +8497,5 @@
                 if test "x$with_silk" != "xno" -a "x$with_silk" != "x"; then
                     CFLAGS="$CFLAGS -I$with_silk/interface"
-		    CPPFLAGS="$CPPFLAGS -I$with_silk/interface"
+                    CPPFLAGS="$CPPFLAGS -I$with_silk/interface"
                     LDFLAGS="$LDFLAGS -L$with_silk"
                     { $as_echo "$as_me:${as_lineno-$LINENO}: result: Using SILK prefix... $with_silk" >&5
@@ -8593,5 +8596,5 @@
                 if test "x$with_opus" != "xno" -a "x$with_opus" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opus/include"
-		    CPPFLAGS="$CPPFLAGS -I$with_opus/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opus/include"
                     LDFLAGS="$LDFLAGS -L$with_opus/lib"
                     { $as_echo "$as_me:${as_lineno-$LINENO}: result: Using OPUS prefix... $with_opus" >&5
Index: /pjproject/trunk/aconfigure.ac
===================================================================
--- /pjproject/trunk/aconfigure.ac	(revision 5795)
+++ /pjproject/trunk/aconfigure.ac	(revision 5796)
@@ -1584,4 +1584,5 @@
                 if test "x$with_ssl" != "xno" -a "x$with_ssl" != "x"; then
                     CFLAGS="$CFLAGS -I$with_ssl/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_ssl/include"
                     LDFLAGS="$LDFLAGS -L$with_ssl/lib"
                     AC_MSG_RESULT([Using SSL prefix... $with_ssl])
@@ -1723,4 +1724,5 @@
                 if test "x$with_opencore_amr" != "xno" -a "x$with_opencore_amr" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opencore_amr/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opencore_amr/include"
                     LDFLAGS="$LDFLAGS -L$with_opencore_amr/lib"
                     AC_MSG_RESULT([Using OpenCORE AMR prefix... $with_opencore_amr])
@@ -1728,4 +1730,5 @@
                 if test "x$with_opencore_amrwbenc" != "xno" -a "x$with_opencore_amrwbenc" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opencore_amrwbenc/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opencore_amrwbenc/include"
                     LDFLAGS="$LDFLAGS -L$with_opencore_amrwbenc/lib"
                     AC_MSG_RESULT([Using OpenCORE AMRWB-enc prefix... $with_opencore_amrwbenc])
@@ -1790,5 +1793,5 @@
                 if test "x$with_silk" != "xno" -a "x$with_silk" != "x"; then
                     CFLAGS="$CFLAGS -I$with_silk/interface"
-		    CPPFLAGS="$CPPFLAGS -I$with_silk/interface"
+                    CPPFLAGS="$CPPFLAGS -I$with_silk/interface"
                     LDFLAGS="$LDFLAGS -L$with_silk"
                     AC_MSG_RESULT([Using SILK prefix... $with_silk])
@@ -1837,5 +1840,5 @@
                 if test "x$with_opus" != "xno" -a "x$with_opus" != "x"; then
                     CFLAGS="$CFLAGS -I$with_opus/include"
-		    CPPFLAGS="$CPPFLAGS -I$with_opus/include"
+                    CPPFLAGS="$CPPFLAGS -I$with_opus/include"
                     LDFLAGS="$LDFLAGS -L$with_opus/lib"
                     AC_MSG_RESULT([Using OPUS prefix... $with_opus])