Index: pjproject/trunk/pjproject-vs14.sln
===================================================================
--- pjproject/trunk/pjproject-vs14.sln	(revision 5801)
+++ pjproject/trunk/pjproject-vs14.sln	(revision 5802)
@@ -1937,45 +1937,25 @@
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug|ARM.ActiveCfg = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug|Win32.ActiveCfg = Debug|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug|Win32.Build.0 = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug|x64.ActiveCfg = Debug|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug|x64.Build.0 = Debug|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|Any CPU.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|Any CPU.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|ARM.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|ARM.Build.0 = Release|x64
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|Any CPU.ActiveCfg = Debug|Win32
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|ARM.ActiveCfg = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|Win32.ActiveCfg = Debug|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|Win32.Build.0 = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|x64.ActiveCfg = Debug|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Dynamic|x64.Build.0 = Debug|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|Any CPU.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|Any CPU.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|ARM.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|ARM.Build.0 = Release|x64
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|Any CPU.ActiveCfg = Debug|Win32
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|ARM.ActiveCfg = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|Win32.ActiveCfg = Debug|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|Win32.Build.0 = Debug|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|x64.ActiveCfg = Debug|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Debug-Static|x64.Build.0 = Debug|x64
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|Any CPU.ActiveCfg = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|ARM.ActiveCfg = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|Win32.ActiveCfg = Release|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|Win32.Build.0 = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|x64.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release|x64.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|Any CPU.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|Any CPU.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|ARM.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|ARM.Build.0 = Release|x64
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|Any CPU.ActiveCfg = Release|Win32
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|ARM.ActiveCfg = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|Win32.ActiveCfg = Release|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|Win32.Build.0 = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|x64.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Dynamic|x64.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|Any CPU.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|Any CPU.Build.0 = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|ARM.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|ARM.Build.0 = Release|x64
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|Any CPU.ActiveCfg = Release|Win32
+		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|ARM.ActiveCfg = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|Win32.ActiveCfg = Release|Win32
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|Win32.Build.0 = Release|Win32
 		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|x64.ActiveCfg = Release|x64
-		{63AC6D7A-5D97-40C2-9AF2-E13AA1F9567C}.Release-Static|x64.Build.0 = Release|x64
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution